#! /usr/bin/perl
use Net::FTP;
use strict;

my $DIR = "/usr/local/bin/ngn";
my $CFGFILE = "ngn.cfg";

# get
my ($host, $port, $path, $login, $pass);

# put, zip
my ($spool, $perm, $rotate);

# convert
my ($text, $aregexp, $bregexp);

my $filename;

my $count = 0; #count of loaded files

$host = "gate.bitel.ru";
$port = 21;
$path = "/home/airat/outngn";
$login = "airat";
$pass = "airat333";
$spool = $DIR."/in";
$text = $DIR."/out";

print "\n*********************\n";
print "\nCollector NGN started\n";
print   "*********************\n";
print localtime(time)."\n";

# Get data from the configuration file
parse_cfg("$DIR/$CFGFILE");

my $ftp = Net::FTP->new($host.":".$port, Timeout => 30, Debug => 0) or die "ERROR Cannot connect to $host:$port: $@";
print "INFO  Open FTP-connect with $host:$port\n";

$ftp->login($login, $pass) or die "ERROR Cannot login ", $ftp->message;
print "INFO  Login as $login is success\n";

$ftp->cwd($path) or die "ERROR Cannot change working directory ", $ftp->message;
print "INFO  Directory change for $path\n";
$ftp->binary();
my @list = $ftp->ls($path) or die "ERROR Cannot LS directory ", $ftp->message;
print "INFO  Filenames is loaded\n";

foreach(@list)
{
  if(!/.loaded$/)
  {
	if(/\/([^\/]*)$/)
	{
	  $filename = $1;
	}
	if($ftp->get($_,"$spool/$filename") )
	{
		print "INFO  File '$_' is loaded\n";
		$ftp->rename( $_, "$_.loaded" ) or die "ERROR Cannot rename file '$_' to '$_.loaded'\n";
		print "INFO  File '$_' is renamed\n";
		$count++;
	}
	else
	{
	  print "ERROR File $_ is not loaded\n", $ftp->message;
	}
	
  }
}
$ftp->quit();
print "INFO FTP connect closed. Loaded $count files\n";
if($count > 0)
{
  print "INFO  Covert files\n";
  my $request = `$DIR/convertNGN.pl -i $spool -o $text`;
  print 'INFO  $request\n';
}

print localtime(time)."\n";
print "*********************\n";
print "      the end        \n";
print "*********************\n";

#
# Parsing the configuration file
#
sub parse_cfg
{
  my $file = shift;

  open(CFGFILE, "$file") || die "ERROR Ошибка при открытии $file. $!";
  print "INFO  File '$file' open\n";

  my @contents = <CFGFILE>;
  close(CFGFILE);

  foreach( @contents )
  {
	  $host = $1 if(/^host="(.*)";$/);
	  $port = $1 if(/^port=(\d*);$/);
	  $path = $1 if(/^path=(.*);$/);
	  $login = $1 if(/^login=(.*);$/);
	  $pass = $1 if(/^pass=(.*);$/);
	  $spool = $1 if(/^spool=(.*);$/);
	  $text = $1 if(/^text=(.*);$/);
  }
	
  if( $host eq "" || $port eq "" || $path eq "" || $login eq "" || $pass eq "")
  {
	print "ERROR Некоректный конфигурационный файл! Считанные параметры: host=$host; port=$port; path=$path; login=$login; pass=$pass;\n";
	exit 0;
  }
  else
  {
	print "INFO  Успешно считаны параметры:  host=$host; port=$port; path=$path; login=$login; pass=$pass;\n";
	print "INFO  Файл '$file' успешно обработан\n";
  }
}

